Index: /LMDZ6/branches/Ocean_skin/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ6/branches/Ocean_skin/libf/phylmd/physiq_mod.F90	(revision 3604)
+++ /LMDZ6/branches/Ocean_skin/libf/phylmd/physiq_mod.F90	(revision 3605)
@@ -25,5 +25,5 @@
     USE dimphy
     USE infotrac_phy, ONLY: nqtot, nbtr, nqo, type_trac
-    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, nbp_lev, klon_glo
+    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, nbp_lev, klon_glo, grid1dTo2d_glo, grid_type, unstructured
     USE mod_phys_lmdz_para
     USE iophy
@@ -38,4 +38,7 @@
 #ifdef CPP_Dust
     USE phytracr_spl_mod, ONLY: phytracr_spl
+#endif
+#ifdef CPP_StratAer
+    USE strataer_mod, ONLY: strataer_init
 #endif
     USE phys_local_var_mod, ONLY: phys_local_var_init, phys_local_var_end, &
@@ -117,4 +120,6 @@
        zustar, zu10m, zv10m, rh2m, qsat2m, &
        zq2m, zt2m, weak_inversion, &
+       zq2m_cor,zt2m_cor,zu10m_cor,zv10m_cor, & ! pour corriger d'un bug
+       zrh2m_cor,zqsat2m_cor, &
        zt2m_min_mon, zt2m_max_mon,   &         ! pour calcul_divers.h
        t2m_min_mon, t2m_max_mon,  &            ! pour calcul_divers.h
@@ -170,5 +175,5 @@
        !    Deep convective variables used in phytrac
        pmflxr, pmflxs,  &
-       wdtrainA, wdtrainM,  &
+       wdtrainA, wdtrainS, wdtrainM,  &
        upwd, dnwd, &
        ep,  &
@@ -180,4 +185,5 @@
        ev, &
        elij, &
+       qtaa, &
        clw, &
        epmlmMm, eplaMm, &
@@ -243,6 +249,6 @@
 #endif
     USE indice_sol_mod
-    USE phytrac_mod, ONLY : phytrac
-    USE carbon_cycle_mod, ONLY : infocfields_init
+    USE phytrac_mod, ONLY : phytrac_init, phytrac
+    USE carbon_cycle_mod, ONLY : infocfields_init, RCO2_glo, carbon_cycle_rad
 
 #ifdef CPP_RRTM
@@ -265,4 +271,12 @@
     USE ACAMA_GWD_rando_m, only: ACAMA_GWD_rando
     USE VERTICAL_LAYERS_MOD, ONLY: aps,bps
+    USE etat0_limit_unstruct_mod
+#ifdef CPP_XIOS
+    USE xios, ONLY: xios_update_calendar, xios_context_finalize
+#endif
+    USE limit_read_mod, ONLY : init_limit_read
+    USE regr_horiz_time_climoz_m, ONLY: regr_horiz_time_climoz
+    USE readaerosol_mod, ONLY : init_aero_fromfile
+    USE readaerosolstrato_m, ONLY : init_readaerosolstrato
 
     IMPLICIT NONE
@@ -323,10 +337,11 @@
     include "dimpft.h"
     !======================================================================
+    LOGICAL, SAVE :: ok_volcan ! pour activer les diagnostics volcaniques
+    !$OMP THREADPRIVATE(ok_volcan)
     LOGICAL ok_cvl  ! pour activer le nouveau driver pour convection KE
     PARAMETER (ok_cvl=.TRUE.)
     LOGICAL ok_gust ! pour activer l'effet des gust sur flux surface
     PARAMETER (ok_gust=.FALSE.)
-    integer iflag_radia     ! active ou non le rayonnement (MPL)
-    save iflag_radia
+    INTEGER, SAVE :: iflag_radia     ! active ou non le rayonnement (MPL)
     !$OMP THREADPRIVATE(iflag_radia)
     !======================================================================
@@ -363,21 +378,21 @@
     !======================================================================
     LOGICAL ok_journe ! sortir le fichier journalier
-    save ok_journe
+    SAVE ok_journe
     !$OMP THREADPRIVATE(ok_journe)
     !
     LOGICAL ok_mensuel ! sortir le fichier mensuel
-    save ok_mensuel
+    SAVE ok_mensuel
     !$OMP THREADPRIVATE(ok_mensuel)
     !
     LOGICAL ok_instan ! sortir le fichier instantane
-    save ok_instan
+    SAVE ok_instan
     !$OMP THREADPRIVATE(ok_instan)
     !
     LOGICAL ok_LES ! sortir le fichier LES 
-    save ok_LES                            
+    SAVE ok_LES                            
     !$OMP THREADPRIVATE(ok_LES)                  
     !
     LOGICAL callstats ! sortir le fichier stats 
-    save callstats                            
+    SAVE callstats                            
     !$OMP THREADPRIVATE(callstats)                  
     !
@@ -385,9 +400,9 @@
     PARAMETER (ok_region=.FALSE.)
     !======================================================================
-    real seuil_inversion
-    save seuil_inversion
+    REAL seuil_inversion
+    SAVE seuil_inversion
     !$OMP THREADPRIVATE(seuil_inversion)
-    integer iflag_ratqs
-    save iflag_ratqs
+    INTEGER iflag_ratqs
+    SAVE iflag_ratqs
     !$OMP THREADPRIVATE(iflag_ratqs)
     real facteur
@@ -396,9 +411,9 @@
     REAL tau_overturning_th(klon)
 
-    integer lmax_th(klon)
-    integer limbas(klon)
-    real ratqscth(klon,klev)
-    real ratqsdiff(klon,klev)
-    real zqsatth(klon,klev)
+    INTEGER lmax_th(klon)
+    INTEGER limbas(klon)
+    REAL ratqscth(klon,klev)
+    REAL ratqsdiff(klon,klev)
+    REAL zqsatth(klon,klev)
 
     !======================================================================
@@ -497,16 +512,15 @@
     CHARACTER*3 region
     PARAMETER(region='3d')
-    logical ok_hf
-    !
-    save ok_hf
+    LOGICAL ok_hf
+    !
+    SAVE ok_hf
     !$OMP THREADPRIVATE(ok_hf)
 
-    INTEGER,PARAMETER :: longcles=20
-    REAL,SAVE :: clesphy0(longcles)
+    INTEGER, PARAMETER :: longcles=20
+    REAL, SAVE :: clesphy0(longcles)
     !$OMP THREADPRIVATE(clesphy0)
     !
     ! Variables propres a la physique
-    INTEGER itap
-    SAVE itap                   ! compteur pour la physique
+    INTEGER, SAVE :: itap         ! compteur pour la physique
     !$OMP THREADPRIVATE(itap)
 
@@ -514,5 +528,5 @@
     !$OMP THREADPRIVATE(abortphy)
     !
-    REAL,save ::  solarlong0
+    REAL,SAVE ::  solarlong0
     !$OMP THREADPRIVATE(solarlong0)
 
@@ -531,7 +545,5 @@
     ! Variables liees a la convection de K. Emanuel (sb):
     !
-    REAL bas, top             ! cloud base and top levels
-    SAVE bas
-    SAVE top
+    REAL, SAVE :: bas, top             ! cloud base and top levels
     !$OMP THREADPRIVATE(bas, top)
     !------------------------------------------------------------------
@@ -551,5 +563,6 @@
     ! Variables li\'ees \`a la poche froide (jyg)
 
-    REAL mip(klon,klev)  ! mass flux shed by the adiab ascent at each level
+!!    REAL mipsh(klon,klev)  ! mass flux shed by the adiab ascent at each level
+!!      Moved to phys_state_var_mod
     !
     REAL wape_prescr, fip_prescr
@@ -568,14 +581,11 @@
 !!    REAL, DIMENSION(klon,klev)     :: dql_sat
 
-    real, save :: alp_bl_prescr=0.
-    real, save :: ale_bl_prescr=0.
-
-    real, save :: wake_s_min_lsp=0.1
-
+    REAL, SAVE :: alp_bl_prescr=0.
+    REAL, SAVE :: ale_bl_prescr=0.
+    REAL, SAVE :: wake_s_min_lsp=0.1
     !$OMP THREADPRIVATE(alp_bl_prescr,ale_bl_prescr)
     !$OMP THREADPRIVATE(wake_s_min_lsp)
 
-
-    real ok_wk_lsp(klon)
+    REAL ok_wk_lsp(klon)
 
     !RC
@@ -590,4 +600,10 @@
                                                         ! gust-front in the grid cell.
     !$OMP THREADPRIVATE(iflag_alp_wk_cond)
+
+    INTEGER,  SAVE               :: iflag_bug_t2m_ipslcm61=1 !
+    !$OMP THREADPRIVATE(iflag_bug_t2m_ipslcm61)
+    INTEGER,  SAVE               :: iflag_bug_t2m_stab_ipslcm61=-1 !
+    !$OMP THREADPRIVATE(iflag_bug_t2m_stab_ipslcm61)
+
     REAL t_w(klon,klev),q_w(klon,klev) ! temperature and moisture profiles in the wake region
     REAL t_x(klon,klev),q_x(klon,klev) ! temperature and moisture profiles in the off-wake region
@@ -727,5 +743,5 @@
     REAL :: jD_eq
 
-    LOGICAL, parameter :: new_orbit = .true.
+    LOGICAL, parameter :: new_orbit = .TRUE.
 
     !
@@ -913,6 +929,6 @@
     INTEGER kcbot(klon), kctop(klon), kdtop(klon)
     !
-    real ratqsbas,ratqshaut,tau_ratqs
-    save ratqsbas,ratqshaut,tau_ratqs
+    REAL ratqsbas,ratqshaut,tau_ratqs
+    SAVE ratqsbas,ratqshaut,tau_ratqs
     !$OMP THREADPRIVATE(ratqsbas,ratqshaut,tau_ratqs)
     REAL, SAVE :: ratqsp0=50000., ratqsdp=20000.
@@ -920,19 +936,15 @@
 
     ! Parametres lies au nouveau schema de nuages (SB, PDF)
-    real fact_cldcon
-    real facttemps
-    logical ok_newmicro
-    save ok_newmicro
+    REAL, SAVE :: fact_cldcon
+    REAL, SAVE :: facttemps
+    !$OMP THREADPRIVATE(fact_cldcon,facttemps)
+    LOGICAL, SAVE :: ok_newmicro
     !$OMP THREADPRIVATE(ok_newmicro)
-    !real ref_liq_pi(klon,klev), ref_ice_pi(klon,klev)
-    save fact_cldcon,facttemps
-    !$OMP THREADPRIVATE(fact_cldcon,facttemps)
-
-    integer iflag_cld_th
-    save iflag_cld_th
+
+    INTEGER, SAVE :: iflag_cld_th
     !$OMP THREADPRIVATE(iflag_cld_th)
 !IM logical ptconv(klon,klev)  !passe dans phys_local_var_mod
     !IM cf. AM 081204 BEG
-    logical ptconvth(klon,klev)
+    LOGICAL ptconvth(klon,klev)
     !IM cf. AM 081204 END
     !
@@ -941,5 +953,4 @@
     !======================================================================
     !
-
     !
 !JLD    integer itau_w   ! pas de temps ecriture = itap + itau_phy
@@ -1007,16 +1018,15 @@
 !JLD    REAL zstophy, zout
 
-    character*20 modname
-    character*80 abort_message
-    logical, save ::  ok_sync, ok_sync_omp
+    CHARACTER*20 modname
+    CHARACTER*80 abort_message
+    LOGICAL, SAVE ::  ok_sync, ok_sync_omp
     !$OMP THREADPRIVATE(ok_sync)
-    real date0
+    REAL date0
 
     ! essai writephys
-    integer fid_day, fid_mth, fid_ins
-    parameter (fid_ins = 1, fid_day = 2, fid_mth = 3) 
-    integer prof2d_on, prof3d_on, prof2d_av, prof3d_av
-    parameter (prof2d_on = 1, prof3d_on = 2, &
-         prof2d_av = 3, prof3d_av = 4)
+    INTEGER fid_day, fid_mth, fid_ins
+    PARAMETER (fid_ins = 1, fid_day = 2, fid_mth = 3) 
+    INTEGER prof2d_on, prof3d_on, prof2d_av, prof3d_av
+    PARAMETER (prof2d_on = 1, prof3d_on = 2, prof2d_av = 3, prof3d_av = 4)
     REAL ztsol(klon)
     REAL q2m(klon,nbsrf)  ! humidite a 2m
@@ -1070,5 +1080,5 @@
     ! Declaration des constantes et des fonctions thermodynamiques
     !
-    LOGICAL,SAVE :: first=.true.
+    LOGICAL,SAVE :: first=.TRUE.
     !$OMP THREADPRIVATE(first)
 
@@ -1106,5 +1116,5 @@
     ! Declarations pour Simulateur COSP
     !============================================================
-    real :: mr_ozone(klon,klev)
+    real :: mr_ozone(klon,klev), phicosp(klon,klev)
 
     !IM stations CFMIP
@@ -1164,10 +1174,11 @@
     REAL zzz
     !albedo SB >>>
-    real,dimension(6),save :: SFRWL
+    REAL,DIMENSION(6), SAVE :: SFRWL
+!$OMP THREADPRIVATE(SFRWL)
     !albedo SB <<<
 
     !--OB variables for mass fixer (hard coded for now)
-    logical, parameter :: mass_fixer=.false.
-    real qql1(klon),qql2(klon),corrqql
+    LOGICAL, PARAMETER :: mass_fixer=.FALSE.
+    REAL qql1(klon),qql2(klon),corrqql
 
     REAL pi
@@ -1183,4 +1194,8 @@
     pdtphys=pdtphys_
     CALL update_time(pdtphys)
+    phys_tstep=NINT(pdtphys)
+#ifdef CPP_XIOS
+    IF (.NOT. debut .AND. is_omp_master) CALL xios_update_calendar(itap+1)
+#endif
 
     !======================================================================
@@ -1211,15 +1226,17 @@
 
     ! Quick check on pressure levels:
-    call assert(paprs(:, nbp_lev + 1) < paprs(:, nbp_lev), &
+    CALL assert(paprs(:, nbp_lev + 1) < paprs(:, nbp_lev), &
             "physiq_mod paprs bad order")
 
     IF (first) THEN 
+       CALL init_etat0_limit_unstruct
+       IF (.NOT. create_etat0_limit) CALL init_limit_read(days_elapsed)
        !CR:nvelles variables convection/poches froides
 
-       print*, '================================================='
-       print*, 'Allocation des variables locales et sauvegardees'
+       WRITE(lunout,*) '================================================='
+       WRITE(lunout,*) 'Allocation des variables locales et sauvegardees'
+       WRITE(lunout,*) '================================================='
        CALL phys_local_var_init
        !
-       pasphys=pdtphys
        !     appel a la lecture du run.def physique
        CALL conf_phys(ok_journe, ok_mensuel, &
@@ -1230,5 +1247,6 @@
             fact_cldcon, facttemps,ok_newmicro,iflag_radia, &
             iflag_cld_th,iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
-            ok_ade, ok_aie, ok_alw, ok_cdnc, aerosol_couple,  chemistry_couple, &
+            ok_ade, ok_aie, ok_alw, ok_cdnc, ok_volcan, aerosol_couple, &
+            chemistry_couple, &
             flag_aerosol, flag_aerosol_strat, flag_aer_feedback, new_aod, &
             flag_bc_internal_mixture, bl95_b0, bl95_b1, &
@@ -1239,4 +1257,11 @@
        CALL phys_state_var_init(read_climoz)
        CALL phys_output_var_init
+       IF (read_climoz>=1 .AND. create_etat0_limit .AND. grid_type==unstructured) & 
+          CALL regr_horiz_time_climoz(read_climoz,ok_daily_climoz)
+
+#ifdef CPP_StratAer
+       CALL strataer_init
+#endif
+
        print*, '================================================='
        !
@@ -1245,5 +1270,6 @@
           WRITE (lunout, *) ' iflag_ice_thermo==1 requires 3 H2O tracers ', &
                '(H2Ov, H2Ol, H2Oi) but nqo=', nqo, '. Might as well stop here.'
-          STOP
+          abort_message='see above'
+          CALL abort_physic(modname,abort_message,1)
        ENDIF
 
@@ -1258,5 +1284,5 @@
 
        itau_con=0
-       first=.false.
+       first=.FALSE.
 
     ENDIF  ! first
@@ -1287,5 +1313,11 @@
 ! secondes
        tau_gl=86400.*tau_gl
-       print*,'debut physiq_mod tau_gl=',tau_gl
+       WRITE(lunout,*) 'debut physiq_mod tau_gl=',tau_gl
+
+       iflag_bug_t2m_ipslcm61 = 1
+       CALL getin_p('iflag_bug_t2m_ipslcm61', iflag_bug_t2m_ipslcm61)
+       iflag_bug_t2m_stab_ipslcm61 = -1
+       CALL getin_p('iflag_bug_t2m_stab_ipslcm61', iflag_bug_t2m_stab_ipslcm61)
+
        CALL getin_p('iflag_alp_wk_cond', iflag_alp_wk_cond) 
        CALL getin_p('random_notrig_max',random_notrig_max)
@@ -1318,4 +1350,21 @@
        CALL getin_p('NVM',nvm_lmdz)
 
+       WRITE(lunout,*) 'iflag_alp_wk_cond=',  iflag_alp_wk_cond
+       WRITE(lunout,*) 'random_ntrig_max=',   random_notrig_max
+       WRITE(lunout,*) 'ok_adjwk=',           ok_adjwk
+       WRITE(lunout,*) 'iflag_adjwk=',        iflag_adjwk
+       WRITE(lunout,*) 'qtcon_multistep_max=',dtcon_multistep_max 
+       WRITE(lunout,*) 'qdcon_multistep_max=',dqcon_multistep_max 
+       WRITE(lunout,*) 'ratqsp0=',            ratqsp0
+       WRITE(lunout,*) 'ratqsdp=',            ratqsdp 
+       WRITE(lunout,*) 'iflag_wake_tend=',    iflag_wake_tend
+       WRITE(lunout,*) 'ok_bad_ecmwf_thermo=',ok_bad_ecmwf_thermo 
+       WRITE(lunout,*) 'ok_bug_cv_trac=',     ok_bug_cv_trac 
+       WRITE(lunout,*) 'ok_bug_split_th=',    ok_bug_split_th
+       WRITE(lunout,*) 'fl_ebil=',            fl_ebil
+       WRITE(lunout,*) 'fl_cor_ebil=',        fl_cor_ebil
+       WRITE(lunout,*) 'iflag_phytrac=',      iflag_phytrac
+       WRITE(lunout,*) 'NVM=',                nvm_lmdz
+
        !--PC: defining fields to be exchanged between LMDz, ORCHIDEE and NEMO
        WRITE(lunout,*) 'Call to infocfields from physiq'
@@ -1369,4 +1418,8 @@
        ENDIF
 
+       tau_aero(:,:,:,:) = 1.e-15
+       piz_aero(:,:,:,:) = 1.
+       cg_aero(:,:,:,:)  = 0.
+
        IF (aerosol_couple .AND. (config_inca /= "aero" &
             .AND. config_inca /= "aeNP ")) THEN
@@ -1376,6 +1429,4 @@
           CALL abort_physic (modname,abort_message,1)
        ENDIF
-
-
 
        rnebcon0(:,:) = 0.0
@@ -1417,14 +1468,12 @@
        ! pour obtenir le meme resultat.
 !jyg for fh<
-!!       dtime=pdtphys
-       dtime=NINT(pdtphys)
-       WRITE(lunout,*) 'Pas de temps dtime pdtphys ',dtime,pdtphys
-       IF (abs(dtime-pdtphys)>1.e-10) THEN
+       WRITE(lunout,*) 'Pas de temps phys_tstep pdtphys ',phys_tstep,pdtphys
+       IF (abs(phys_tstep-pdtphys)>1.e-10) THEN
           abort_message='pas de temps doit etre entier en seconde pour orchidee et XIOS'
           CALL abort_physic(modname,abort_message,1)
        ENDIF
 !>jyg
-       IF (MOD(NINT(86400./dtime),nbapp_rad).EQ.0) THEN
-          radpas = NINT( 86400./dtime)/nbapp_rad
+       IF (MOD(NINT(86400./phys_tstep),nbapp_rad).EQ.0) THEN
+          radpas = NINT( 86400./phys_tstep)/nbapp_rad
        ELSE 
           WRITE(lunout,*) 'le nombre de pas de temps physique doit etre un ', &
@@ -1436,9 +1485,9 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
-       IF (nbapp_cv .EQ. 0) nbapp_cv=86400./dtime
-       IF (nbapp_wk .EQ. 0) nbapp_wk=86400./dtime
+       IF (nbapp_cv .EQ. 0) nbapp_cv=86400./phys_tstep
+       IF (nbapp_wk .EQ. 0) nbapp_wk=86400./phys_tstep
        print *,'physiq, nbapp_cv, nbapp_wk ',nbapp_cv,nbapp_wk
-       IF (MOD(NINT(86400./dtime),nbapp_cv).EQ.0) THEN
-          cvpas_0 = NINT( 86400./dtime)/nbapp_cv
+       IF (MOD(NINT(86400./phys_tstep),nbapp_cv).EQ.0) THEN
+          cvpas_0 = NINT( 86400./phys_tstep)/nbapp_cv
           cvpas = cvpas_0
        print *,'physiq, cvpas ',cvpas
@@ -1450,9 +1499,9 @@
           abort_message='nbre de pas de temps physique n est pas multiple ' &
                // 'de nbapp_cv'
-          call abort_physic(modname,abort_message,1)
-       ENDIF
-       IF (MOD(NINT(86400./dtime),nbapp_wk).EQ.0) THEN
-          wkpas = NINT( 86400./dtime)/nbapp_wk
-       print *,'physiq, wkpas ',wkpas
+          CALL abort_physic(modname,abort_message,1)
+       ENDIF
+       IF (MOD(NINT(86400./phys_tstep),nbapp_wk).EQ.0) THEN
+          wkpas = NINT( 86400./phys_tstep)/nbapp_wk
+!       print *,'physiq, wkpas ',wkpas
        ELSE 
           WRITE(lunout,*) 'le nombre de pas de temps physique doit etre un ', &
@@ -1462,22 +1511,208 @@
           abort_message='nbre de pas de temps physique n est pas multiple ' &
                // 'de nbapp_wk'
-          call abort_physic(modname,abort_message,1)
+          CALL abort_physic(modname,abort_message,1)
        ENDIF
        ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-
+       CALL init_iophy_new(latitude_deg,longitude_deg)
+
+          !===================================================================
+          !IM stations CFMIP
+          nCFMIP=npCFMIP
+          OPEN(98,file='npCFMIP_param.data',status='old', &
+               form='formatted',iostat=iostat)
+          IF (iostat == 0) THEN
+             READ(98,*,end=998) nCFMIP
+998          CONTINUE
+             CLOSE(98)
+             CONTINUE
+             IF(nCFMIP.GT.npCFMIP) THEN
+                print*,'nCFMIP > npCFMIP : augmenter npCFMIP et recompiler'
+                CALL abort_physic("physiq", "", 1)
+             ELSE
+                print*,'physiq npCFMIP=',npCFMIP,'nCFMIP=',nCFMIP
+             ENDIF
+
+             !
+             ALLOCATE(tabCFMIP(nCFMIP))
+             ALLOCATE(lonCFMIP(nCFMIP), latCFMIP(nCFMIP))
+             ALLOCATE(tabijGCM(nCFMIP))
+             ALLOCATE(lonGCM(nCFMIP), latGCM(nCFMIP))
+             ALLOCATE(iGCM(nCFMIP), jGCM(nCFMIP))
+             !
+             ! lecture des nCFMIP stations CFMIP, de leur numero 
+             ! et des coordonnees geographiques lonCFMIP, latCFMIP
+             !
+             CALL read_CFMIP_point_locations(nCFMIP, tabCFMIP,  &
+                  lonCFMIP, latCFMIP)
+             !
+             ! identification des
+             ! 1) coordonnees lonGCM, latGCM des points CFMIP dans la
+             ! grille de LMDZ
+             ! 2) indices points tabijGCM de la grille physique 1d sur
+             ! klon points
+             ! 3) indices iGCM, jGCM de la grille physique 2d
+             !
+             CALL LMDZ_CFMIP_point_locations(nCFMIP, lonCFMIP, latCFMIP, &
+                  tabijGCM, lonGCM, latGCM, iGCM, jGCM)
+             !
+          ELSE
+             ALLOCATE(tabijGCM(0))
+             ALLOCATE(lonGCM(0), latGCM(0))
+             ALLOCATE(iGCM(0), jGCM(0))
+          ENDIF
+
+#ifdef CPP_IOIPSL
+
+       !$OMP MASTER
+       ! FH : if ok_sync=.true. , the time axis is written at each time step
+       ! in the output files. Only at the end in the opposite case
+       ok_sync_omp=.FALSE.
+       CALL getin('ok_sync',ok_sync_omp)
+       CALL phys_output_open(longitude_deg,latitude_deg,nCFMIP,tabijGCM, &
+            iGCM,jGCM,lonGCM,latGCM, &
+            jjmp1,nlevSTD,clevSTD,rlevSTD, phys_tstep,ok_veget, &
+            type_ocean,iflag_pbl,iflag_pbl_split,ok_mensuel,ok_journe, &
+            ok_hf,ok_instan,ok_LES,ok_ade,ok_aie, &
+            read_climoz, phys_out_filestations, &
+            new_aod, aerosol_couple, &
+            flag_aerosol_strat, pdtphys, paprs, pphis,  &
+            pplay, lmax_th, ptconv, ptconvth, ivap,  &
+            d_u, d_t, qx, d_qx, zmasse, ok_sync_omp)
+       !$OMP END MASTER
+       !$OMP BARRIER
+       ok_sync=ok_sync_omp
+
+       freq_outNMC(1) = ecrit_files(7)
+       freq_outNMC(2) = ecrit_files(8)
+       freq_outNMC(3) = ecrit_files(9)
+       WRITE(lunout,*)'OK freq_outNMC(1)=',freq_outNMC(1)
+       WRITE(lunout,*)'OK freq_outNMC(2)=',freq_outNMC(2)
+       WRITE(lunout,*)'OK freq_outNMC(3)=',freq_outNMC(3)
+
+#ifndef CPP_XIOS
+       CALL ini_paramLMDZ_phy(phys_tstep,nid_ctesGCM)
+#endif
+
+#endif
+       ecrit_reg = ecrit_reg * un_jour
+       ecrit_tra = ecrit_tra * un_jour
+
+       !XXXPB Positionner date0 pour initialisation de ORCHIDEE
+       date0 = jD_ref 
+       WRITE(*,*) 'physiq date0 : ',date0
+       !
+
+!       CALL create_climoz(read_climoz)
+      IF (.NOT. create_etat0_limit) CALL init_aero_fromfile(flag_aerosol)  !! initialise aero from file for XIOS interpolation (unstructured_grid)
+      IF (.NOT. create_etat0_limit) CALL init_readaerosolstrato(flag_aerosol_strat)  !! initialise aero strato from file for XIOS interpolation (unstructured_grid)
+
+#ifdef CPP_COSP
+      IF (ok_cosp) THEN
+           DO k = 1, klev
+             DO i = 1, klon
+               phicosp(i,k) = pphi(i,k) + pphis(i)
+             ENDDO
+           ENDDO
+        CALL phys_cosp(itap,phys_tstep,freq_cosp, &
+               ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP, &
+               ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, missing_val, &
+               klon,klev,longitude_deg,latitude_deg,presnivs,overlap, &
+               JrNt,ref_liq,ref_ice, &
+               pctsrf(:,is_ter)+pctsrf(:,is_lic), &
+               zu10m,zv10m,pphis, &
+               zphi,paprs(:,1:klev),pplay,zxtsol,t_seri, &
+               qx(:,:,ivap),zx_rh,cldfra,rnebcon,flwc,fiwc, &
+               prfl(:,1:klev),psfl(:,1:klev), &
+               pmflxr(:,1:klev),pmflxs(:,1:klev), &
+               mr_ozone,cldtau, cldemi)
+      ENDIF
+#endif
+
+#ifdef CPP_COSP2
+        IF (ok_cosp) THEN
+           DO k = 1, klev
+             DO i = 1, klon
+               phicosp(i,k) = pphi(i,k) + pphis(i)
+             ENDDO
+           ENDDO
+          CALL phys_cosp2(itap,phys_tstep,freq_cosp, &
+               ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP, &
+               ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, missing_val, &
+               klon,klev,longitude_deg,latitude_deg,presnivs,overlap, &
+               JrNt,ref_liq,ref_ice, &
+               pctsrf(:,is_ter)+pctsrf(:,is_lic), &
+               zu10m,zv10m,pphis, &
+               zphi,paprs(:,1:klev),pplay,zxtsol,t_seri, &
+               qx(:,:,ivap),zx_rh,cldfra,rnebcon,flwc,fiwc, &
+               prfl(:,1:klev),psfl(:,1:klev), &
+               pmflxr(:,1:klev),pmflxs(:,1:klev), &
+               mr_ozone,cldtau, cldemi)
+       ENDIF
+#endif
+
+#ifdef CPP_COSPV2
+        IF (ok_cosp) THEN
+           DO k = 1, klev
+             DO i = 1, klon
+               phicosp(i,k) = pphi(i,k) + pphis(i)
+             ENDDO
+           ENDDO
+          CALL lmdz_cosp_interface(itap,phys_tstep,freq_cosp, &
+               ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP, &
+               ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, missing_val, &
+               klon,klev,longitude_deg,latitude_deg,presnivs,overlap, &
+               JrNt,ref_liq,ref_ice, &
+               pctsrf(:,is_ter)+pctsrf(:,is_lic), &
+               zu10m,zv10m,pphis, &
+               phicosp,paprs(:,1:klev),pplay,zxtsol,t_seri, &
+               qx(:,:,ivap),zx_rh,cldfra,rnebcon,flwc,fiwc, &
+               prfl(:,1:klev),psfl(:,1:klev), &
+               pmflxr(:,1:klev),pmflxs(:,1:klev), &
+               mr_ozone,cldtau, cldemi)
+       ENDIF
+#endif
+
+       !
+       !
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+       ! Nouvelle initialisation pour le rayonnement RRTM
+       !
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+       CALL iniradia(klon,klev,paprs(1,1:klev+1))
+       ! Initialisation des champs dans phytrac qui sont utilisés par phys_output_write
+       IF (iflag_phytrac == 1 ) THEN
+          CALL phytrac_init()
+        ENDIF
+
+       CALL phys_output_write(itap, pdtphys, paprs, pphis,                    &
+                              pplay, lmax_th, aerosol_couple,                 &
+                              ok_ade, ok_aie, ok_volcan, ivap, iliq, isol, new_aod, ok_sync,&
+                              ptconv, read_climoz, clevSTD,                   &
+                              ptconvth, d_u, d_t, qx, d_qx, zmasse,           &
+                              flag_aerosol, flag_aerosol_strat, ok_cdnc)
+
+#ifdef CPP_XIOS
+       IF (is_omp_master) CALL xios_update_calendar(1)
+#endif
+       IF(read_climoz>=1 .AND. create_etat0_limit) CALL regr_horiz_time_climoz(read_climoz,ok_daily_climoz)
+       CALL create_etat0_limit_unstruct
        CALL phyetat0 ("startphy.nc",clesphy0,tabcntr0)
+
 !jyg<
-       IF (klon_glo==1) THEN
-          IF (iflag_pbl > 1) THEN          
-              pbl_tke(:,:,is_ave) = 0.
-              DO nsrf=1,nbsrf
-                DO k = 1,klev+1
-                     pbl_tke(:,k,is_ave) = pbl_tke(:,k,is_ave) &
-                         +pctsrf(:,nsrf)*pbl_tke(:,k,nsrf)
-                ENDDO
-              ENDDO
-          ELSE   ! (iflag_pbl > 1)
-              pbl_tke(:,:,:) = 0.
-          ENDIF  ! (iflag_pbl > 1)
+       IF (iflag_pbl<=1) THEN
+          ! No TKE for Standard Physics
+          pbl_tke(:,:,:)=0.
+
+       ELSE IF (klon_glo==1) THEN
+          pbl_tke(:,:,is_ave) = 0.
+          DO nsrf=1,nbsrf
+            DO k = 1,klev+1
+                 pbl_tke(:,k,is_ave) = pbl_tke(:,k,is_ave) &
+                     +pctsrf(:,nsrf)*pbl_tke(:,k,nsrf)
+            ENDDO
+          ENDDO
+        ELSE
+          pbl_tke(:,:,is_ave) = 0. !ym missing init : maybe must be initialized in the same way that for klon_glo==1 ??
 !>jyg
        ENDIF
@@ -1496,14 +1731,11 @@
        ENDIF
 
-       CALL printflag( tabcntr0,radpas,ok_journe, &
-            ok_instan, ok_region )
-       !
-       IF (ABS(dtime-pdtphys).GT.0.001) THEN
-          WRITE(lunout,*) 'Pas physique n est pas correct',dtime, &
-               pdtphys
-          abort_message='Pas physique n est pas correct '
-          !           call abort_physic(modname,abort_message,1)
-          dtime=pdtphys
-       ENDIF
+!       IF (ABS(phys_tstep-pdtphys).GT.0.001) THEN
+!          WRITE(lunout,*) 'Pas physique n est pas correct',phys_tstep, &
+!               pdtphys
+!          abort_message='Pas physique n est pas correct '
+!          !           call abort_physic(modname,abort_message,1)
+!          phys_tstep=pdtphys
+!       ENDIF
        IF (nlon .NE. klon) THEN
           WRITE(lunout,*)'nlon et klon ne sont pas coherents', nlon,  &
@@ -1519,5 +1751,5 @@
        ENDIF
        !
-       IF (dtime*REAL(radpas).GT.21600..AND.iflag_cycle_diurne.GE.1) THEN 
+       IF (phys_tstep*REAL(radpas).GT.21600..AND.iflag_cycle_diurne.GE.1) THEN 
           WRITE(lunout,*)'Nbre d appels au rayonnement insuffisant'
           WRITE(lunout,*)"Au minimum 4 appels par jour si cycle diurne"
@@ -1581,53 +1813,8 @@
           !        enddo
 
-          !===================================================================
-          !IM stations CFMIP
-          nCFMIP=npCFMIP
-          OPEN(98,file='npCFMIP_param.data',status='old', &
-               form='formatted',iostat=iostat)
-          IF (iostat == 0) THEN
-             READ(98,*,end=998) nCFMIP
-998          CONTINUE
-             CLOSE(98)
-             CONTINUE
-             IF(nCFMIP.GT.npCFMIP) THEN
-                print*,'nCFMIP > npCFMIP : augmenter npCFMIP et recompiler'
-                CALL abort_physic("physiq", "", 1)
-             ELSE
-                print*,'physiq npCFMIP=',npCFMIP,'nCFMIP=',nCFMIP
-             ENDIF
-
-             !
-             ALLOCATE(tabCFMIP(nCFMIP))
-             ALLOCATE(lonCFMIP(nCFMIP), latCFMIP(nCFMIP))
-             ALLOCATE(tabijGCM(nCFMIP))
-             ALLOCATE(lonGCM(nCFMIP), latGCM(nCFMIP))
-             ALLOCATE(iGCM(nCFMIP), jGCM(nCFMIP))
-             !
-             ! lecture des nCFMIP stations CFMIP, de leur numero 
-             ! et des coordonnees geographiques lonCFMIP, latCFMIP
-             !
-             CALL read_CFMIP_point_locations(nCFMIP, tabCFMIP,  &
-                  lonCFMIP, latCFMIP)
-             !
-             ! identification des
-             ! 1) coordonnees lonGCM, latGCM des points CFMIP dans la
-             ! grille de LMDZ
-             ! 2) indices points tabijGCM de la grille physique 1d sur
-             ! klon points
-             ! 3) indices iGCM, jGCM de la grille physique 2d
-             !
-             CALL LMDZ_CFMIP_point_locations(nCFMIP, lonCFMIP, latCFMIP, &
-                  tabijGCM, lonGCM, latGCM, iGCM, jGCM)
-             !
-          ELSE
-             ALLOCATE(tabijGCM(0))
-             ALLOCATE(lonGCM(0), latGCM(0))
-             ALLOCATE(iGCM(0), jGCM(0))
-          ENDIF
-       ELSE
-          ALLOCATE(tabijGCM(0))
-          ALLOCATE(lonGCM(0), latGCM(0))
-          ALLOCATE(iGCM(0), jGCM(0))
+       !ELSE
+       !   ALLOCATE(tabijGCM(0))
+       !   ALLOCATE(lonGCM(0), latGCM(0))
+       !   ALLOCATE(iGCM(0), jGCM(0))
        ENDIF
 
@@ -1665,5 +1852,5 @@
        !
        !
-       lmt_pas = NINT(86400./dtime * 1.0)   ! tous les jours
+       lmt_pas = NINT(86400./phys_tstep * 1.0)   ! tous les jours
        WRITE(lunout,*)'La frequence de lecture surface est de ',  &
             lmt_pas
@@ -1681,4 +1868,13 @@
        !   Initialisation des sorties
        !=============================================================
+
+#ifdef CPP_XIOS
+       ! Get "missing_val" value from XML files (from temperature variable)
+       !$OMP MASTER
+       CALL xios_get_field_attr("temp",default_value=missing_val_omp)
+       !$OMP END MASTER
+       !$OMP BARRIER
+       missing_val=missing_val_omp
+#endif
 
 #ifdef CPP_XIOS 
@@ -1693,43 +1889,7 @@
 #endif 
 
-#ifdef CPP_IOIPSL
-
-       !$OMP MASTER
-       ! FH : if ok_sync=.true. , the time axis is written at each time step
-       ! in the output files. Only at the end in the opposite case
-       ok_sync_omp=.false.
-       CALL getin('ok_sync',ok_sync_omp)
-       CALL phys_output_open(longitude_deg,latitude_deg,nCFMIP,tabijGCM, &
-            iGCM,jGCM,lonGCM,latGCM, &
-            jjmp1,nlevSTD,clevSTD,rlevSTD, dtime,ok_veget, &
-            type_ocean,iflag_pbl,iflag_pbl_split,ok_mensuel,ok_journe, &
-            ok_hf,ok_instan,ok_LES,ok_ade,ok_aie, &
-            read_climoz, phys_out_filestations, &
-            new_aod, aerosol_couple, &
-            flag_aerosol_strat, pdtphys, paprs, pphis,  &
-            pplay, lmax_th, ptconv, ptconvth, ivap,  &
-            d_u, d_t, qx, d_qx, zmasse, ok_sync_omp)
-       !$OMP END MASTER
-       !$OMP BARRIER
-       ok_sync=ok_sync_omp
-
-       freq_outNMC(1) = ecrit_files(7)
-       freq_outNMC(2) = ecrit_files(8)
-       freq_outNMC(3) = ecrit_files(9)
-       WRITE(lunout,*)'OK freq_outNMC(1)=',freq_outNMC(1)
-       WRITE(lunout,*)'OK freq_outNMC(2)=',freq_outNMC(2)
-       WRITE(lunout,*)'OK freq_outNMC(3)=',freq_outNMC(3)
-
-#ifndef CPP_XIOS
-       CALL ini_paramLMDZ_phy(dtime,nid_ctesGCM)
-#endif
-
-#endif
-       ecrit_reg = ecrit_reg * un_jour
-       ecrit_tra = ecrit_tra * un_jour
-
-       !XXXPB Positionner date0 pour initialisation de ORCHIDEE
-       date0 = jD_ref 
-       WRITE(*,*) 'physiq date0 : ',date0
+
+       CALL printflag( tabcntr0,radpas,ok_journe, &
+            ok_instan, ok_region )
        !
        !
